#include<bits/stdc++.h>
using namespace std;
int main()
{
    long long A, B, K;
    cin>>A>>B>>K;
    long long bad=-1;
    for(long long i=A-A%K; i<B; i+=K)
    {
            bad++;
    }
    long long nach=A;
    if(bad>0)
    {
        for(long long i=1; i<=bad; i++)
        {
            if((((A-A%bad)+bad*i)-A)%2==0)
            {
                nach--;
            }
        }
    }
    cout<<(B-nach)/2+(B-nach)%2<<endl;
    return 0;
}
